;     Baby-peg v0.1
;  - (slide show system)  256 
; ()2008.Art!P email:artip@artip.ru
;   : Freeware 
;  http://nice.artip.ru/?id=doc&a=doc8
;  http://nice.artip.ru/?id=doc&a=doc45
;       
;       COM-port   9600 baud.

PROCESSOR 16f876a
#include "p16f876a.inc"

;    WatchDog! WDT = off
;   = HS. Power Up Timer = 0ff. Brown Out Detect = off

radix dec
#define Button1 PORTA,0 ; "<<"          0
#define Button2 PORTA,1 ; ">>"          255
#define Button3 PORTA,2 ; ">"    
#define Button4 PORTA,3 ; "<"    
BAUD_9600 EQU 12
;  SBRG   12,   8  ( 9600 )
;         SBRG!

org 0x0

NOP
goto START
org 0x04;        MICD2-MC1.    

;**************** main start ****************

START 
org 0x20;  
sleep1    res  1;     
sleep2    res  1;
sleep3    res  1;
a1		  res  1; Button1
b1		  res  1; Button2
temp  	  res  1; Button3 Button4
pause1    res  1;
pause2    res  1;

movlw 0x15; 
call sl;      
clrf PORTB;
BCF STATUS,RP1;
BSF STATUS,RP0;
movlw 0x0	;
movwf TRISB;
clrf STATUS;
bsf PORTB,0;   " "


bsf STATUS,RP0;  1 
movlw b'11000000'; 
movwf TRISC;  TX/RX(RC6/RC7)
movlw BAUD_9600; 
movwf SPBRG;   
bcf PIE1,TXIE;  
bcf TXSTA,BRGH;  
bcf TXSTA,SYNC;  
bsf TXSTA,TXEN;  
bsf PIE1,RCIE;
bcf STATUS,RP0 ;  0
bsf RCSTA,SPEN;  USART 
bsf RCSTA,CREN;  . 
;   ,        , 
; -    

main:
movlw 0x0
movwf a1;   0  "<<"
movwf temp;   0  ">", "<"
movlw 0xff;
movwf b1;   ">>"   255
bcf STATUS, RP1;
bcf STATUS, RP0;
CLRF PORTA; 
bsf STATUS, RP0;
movlw 0x06;
movwf ADCON1;     
movlw 0xff;
movwf TRISA;   
bcf STATUS, RP1;
bcf STATUS, RP0;  0- 

Port_cycle: ;     ,
            ;         1
        btfss   Button1 ;  button1 = 1,    . 
        goto    Press1;   (. 0),   Press1
        btfss   Button2;
        goto    Press2;
        btfss   Button3;
        goto    Press3;
        btfss   Button4;
        goto    Press4;
        goto    Port_cycle;

;    Button1:
Press1:
        call    Pause;           
        btfsc   Button1;
        goto    Port_cycle;  ""    
		call    Pressed1;    Pressed1
		movlw 0x9; 
		call sl;     
 press_cycle1:
		btfsc   Button1;   
		goto    Port_cycle;		
        call    Pressed1;   Pressed1	
        call    Pause;   
		call    Pause;
		goto    press_cycle1;

Press2:
        call    Pause;
        btfsc   Button2;
        goto    Port_cycle;
		call    Pressed2;
		movlw 0x9; 
		call sl;
  press_cycle2:
		btfsc   Button2;
		goto    Port_cycle;		
        call    Pressed2;	
        call    Pause;
		call    Pause;
		goto    press_cycle2;


Press3:
        call    Pause;
        btfsc   Button3;
        goto    Port_cycle;
		call    Pressed3;
		movlw 0x9; 
		call sl;
  press_cycle3:
		btfsc   Button3;
		goto    Port_cycle;		
        call    Pressed3;	
        call    Pause;
		call    Pause;
		goto    press_cycle3;

Press4:
        call    Pause;
        btfsc   Button4;
        goto    Port_cycle;
		call    Pressed4;
		movlw 0x9; 
		call sl;
  press_cycle4:
		btfsc   Button4;
		goto    Port_cycle;		
        call    Pressed4;	
        call    Pause;
		call    Pause;
		goto    press_cycle4;

Pressed1: ;  "<<" = 0
movf a1,0;
call send;
return;

Pressed2: ;  ">>" = 255
movf b1,0;
call send;
return;

Pressed3: ;  ">"
incf temp,1;     2-  
movf temp,0;  temp   0  255     
call send;  255  0,1,2  ..
return;

Pressed4: ;  "<"
decf temp,1;
movf temp,0;
call send;
return;

Pause: ;      pause1  
        movlw   0xaa 
        movwf   pause1
        clrf    pause2
Pause_cycle: 
        decfsz  pause2,f
        goto    Pause_cycle
        decfsz  pause1,f
        goto    Pause_cycle
        return;

send:    
		bcf STATUS,RP0			;   0
		movwf TXREG             ;    W. 
                                ;     
								;          0  255
								;        "0.jpg",     JPEG 
								;    -      
TransWt bsf STATUS,RP0          ;   0 
WtHere  btfss TXSTA,TRMT        ;    
        goto WtHere 
        bcf STATUS,RP0
		return 

sl: ;   
        movwf   sleep1
        clrf    sleep2
		clrf    sleep3
cycle1:
		decfsz  sleep3,f
        goto    cycle1
        decfsz  sleep2,f
        goto    cycle1
        decfsz  sleep1,f
        goto    cycle1
		RETURN
END